"""mainloop.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the main loop for controlling the Game class.
"""

import globals as g

import pygame
from pygame.locals import *

import os, sys; sys.path.insert(0, "..")

import font, level, dialog, game, player

from pgu import gui
from pgu.gui.const import *

class MainLoop:
    def __init__(self, parent):
        if not g.levelDB.has_key(g.START_COLLECTION):
            l = g.levelDB.keys()
            l.sort()
            g.START_COLLECTION = l[0]
        diff = level.getLatestDifficulty(g.START_COLLECTION)
        lev = level.getLatestLevel(g.START_COLLECTION, diff)
        self.game = game.Game(g.START_COLLECTION, diff, lev, onQuit=self.backToTitle)
        self.parent = parent
        g.mouse.changeCursor("pointer")
    
    def loop(self):
        self.game.update()
        self.game.draw(g.screen)
        self.game.events()
        pygame.display.flip()
        g.clock.tick(g.FPS)
        
    def backToTitle(self):
        player.saveLevelDB(g.CONFIG_FILE)
        self.parent.switchLoops("Title")
    