"""s_builder.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the classic definition of the lemming bridge building routine.
"""

from excepts import *

MAX_BRICKS = 12

attrs = {"isDeathAction": False, "isOnGround": True, "mustStartOnGround": True, "propertyChangeOnly": False }
frames = {-1:[[],None] , 1:[[],None]}

def update(lemming):
    if lemming.currentFrame >= lemming.frameCount:
        lemming.bricksLaid += 1
        lemming.currentFrame = 0
        lemming.posX += lemming.direction*2
        lemming.posY -= 1
        lemming.game.collisionMask.lock()
        lemming.game.foreground.lock()
            
        for i in range(lemming.posX-2,lemming.posX+4):
            try:
                if not lemming.checkPos((i,lemming.posY+1), "ground"):
                    lemming.game.foreground.set_at((i,lemming.posY+1), lemming.game.getFavColour())
                    ow, ox, oy, oz = lemming.game.collisionMask.get_at((i,lemming.posY))
                    lemming.game.collisionMask.set_at((i,lemming.posY+1), (ow|128,ox,oy,oz))
            except OutOfThePlayfield:
                pass
    
        lemming.game.foreground.unlock()
        lemming.game.collisionMask.unlock()

        for j in range(lemming.posY-1,lemming.posY-10,-1):
            try:
                if lemming.checkPos((lemming.posX, j), "ground"):
                #stop and turn around the moment it hits the roof (measure col) or sides
                    lemming.direction *= -1
                    if lemming.checkPos((lemming.posX, lemming.posY), "ground"):
                        lemming.posX += lemming.direction
                    lemming.setSkill("s_walker")
                    return
            except OutOfThePlayfield:
                pass

    lemming._incAnimFrame()

    try:
        if not lemming.checkPos((lemming.posX, lemming.posY+1), "ground"):
            lemming.setSkill("s_faller")
            return
    except OutOfThePlayfield:
        lemming.kill()

    if lemming.bricksLaid == MAX_BRICKS:
        lemming.setSkill("s_shrugger")
        return

    return

def set(lemming):
    lemming.currentSkill = "s_builder"
    lemming.currentFrame = 0
    lemming.bricksLaid = 0
    lemming.brick = lemming.game.getFavColour()
    lemming.rect.left = frames[1][1].left
    lemming.rect.right = frames[1][1].right
    lemming.rect.width = frames[1][1].width
    lemming.rect.height = frames[1][1].height
    lemming.frameCount = len(frames[1][0])
    lemming._incAnimFrame()
    return
    
