"""s_leaver.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the classic definition of the lemming exiting safely.
"""

from excepts import *

# I know, I know, the lemmings don't technically get killed when they leave through the exit.
# It means all skill changes from herein are to be ignored. The tag was just unfortunately named.
attrs = {"isDeathAction": True, "isOnGround": False, "mustStartOnGround": False, "propertyChangeOnly": False }
frames = {1:[[],None]}


def update(lemming):
    if lemming.currentFrame == lemming.frameCount:
        lemming.save()
    else:
        lemming._incAnimFrame()
    return

def set(lemming):
    lemming.currentSkill = "s_leaver"
    lemming.currentFrame = 0
    lemming.rect.left = frames[1][1].left
    lemming.rect.right = frames[1][1].right
    lemming.rect.width = frames[1][1].width
    lemming.rect.height = frames[1][1].height
    lemming.frameCount = len(frames[1][0])
    lemming._incAnimFrame()
    return
